function fig_hdl = GridData_build
% GRIDDATA_BUILD
%-------------------------------------------------------------------------------
% File name   : GridData_build.m              
% Generated on: 27-Oct-2008 17:30:50          
% Description :
%-------------------------------------------------------------------------------


% --- VARIABLES ----------------------------------
global MSpScnList MSpf  MSpScn;
persistent strGrid2ndAxis strGrid1stAxis strAverWidth1stAxis
persistent strAverWidth2ndAxis ValPopDataField ValPopVar1stAxis
persistent ValPopVar2ndAxis
if ~isempty(MSpScnList),
	n=length(MSpScnList );
	for ii = 1:n
			cmd=['global ', MSpScnList{ii}];
			eval(cmd);
	end;
end;
if isempty(strGrid2ndAxis),
	strGrid2ndAxis='[-1 : 0.1 : 1]';
end;
if isempty(strGrid1stAxis),
	strGrid1stAxis='[-1 : 0.1 : 1]';
end;
if isempty(strAverWidth1stAxis),
	strAverWidth1stAxis='0.1';
end;
if isempty(strAverWidth2ndAxis),
	strAverWidth2ndAxis='0.1';
end;
if isempty(ValPopDataField),
	ValPopDataField=1;
end;
if isempty(ValPopVar1stAxis),
	ValPopVar1stAxis=1;
end;
if isempty(ValPopVar2ndAxis),
	ValPopVar2ndAxis=1;
end;

fig_hdl=findobj('tag','figGridData');
hndMainGUI=findobj('Tag','figGUIMatSpec');
set(hndMainGUI,'Visible','Off');
if isempty(fig_hdl),
% --- FIGURE -------------------------------------
handles.figGridData = figure(	'Tag', 'figGridData', ...
	'Units', 'characters', ...
	'Position', [73.5 34.7 133.6 26.7], ...
	'Name', 'MatSpec: Map Data', ...
	'MenuBar', 'none', ...
	'NumberTitle', 'off', ...
	'Visible','Off',...
	'Color', get(0,'DefaultUicontrolBackgroundColor'),...
	'CloseRequestFcn',{@closeIt},...
	'NextPlot','new');

% Scale factor to accomodate figure for the system specific graphical properties
%htmp=uicontrol('Style','text','units','pixels',...
%	'fontunits','pixels','position',[10 10 20 10],...
%	'fontsize',10,'string','jg');
%curH=get(htmp,'Extent');
%scalingFact=curH(4)/get(htmp,'fontsize')*.78;
%delete(htmp);
% --- PANELS -------------------------------------
handles.uipResultingVar = uipanel(	'Parent', handles.figGridData, ...
	'Tag', 'uipResultingVar', ...
	'UserData', [], ...
	'Units', 'characters', ...
	'Position', [109.8 3.1 21.6 16.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'Title', 'Resulting variables');

handles.uipanelMapData = uipanel(	'Parent', handles.figGridData, ...
	'Tag', 'uipanelMapData', ...
	'UserData', zeros(1,0), ...
	'Units', 'characters', ...
	'Position', [3.1 8.1 105.1 11.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'Title', 'Map data to axes');

% --- STATIC TEXTS -------------------------------------
handles.txtDataToGrid = uicontrol(	'Parent', handles.figGridData, ...
	'Tag', 'txtDataToGrid', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [3.1 4.8 16.8 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', '2D data to map');

handles.txtOutVar1 = uicontrol(	'Parent', handles.uipResultingVar, ...
	'Tag', 'txtOutVar1', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [3.1 9.9 15.1 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.7 0.7 0.7], ...
	'String', '');

handles.txtOutVar2 = uicontrol(	'Parent', handles.uipResultingVar, ...
	'Tag', 'txtOutVar2', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [3.1 6.5 15.1 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.7 0.7 0.7], ...
	'String', '');

handles.txtOutVarData = uicontrol(	'Parent', handles.uipResultingVar, ...
	'Tag', 'txtOutVarData', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [3.1 1.5 15.1 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.7 0.7 0.7], ...
	'String', '');

handles.txt1stAxis = uicontrol(	'Parent', handles.uipanelMapData, ...
	'Tag', 'txt1stAxis', ...
	'UserData', zeros(1,0), ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [3.1 4.9 10.1 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.7 0.7 0.7], ...
	'String', '1st axis', ...
	'HorizontalAlignment', 'left');

handles.txtGrid = uicontrol(	'Parent', handles.uipanelMapData, ...
	'Tag', 'txtGrid', ...
	'UserData', zeros(1,0), ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [42.1 6.6 33.5 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.7 0.7 0.7], ...
	'String', '[ From : Step : To ]');

handles.txtGridParam = uicontrol(	'Parent', handles.uipanelMapData, ...
	'Tag', 'txtGridParam', ...
	'UserData', zeros(1,0), ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [42.1 8.7 33.5 1.3], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'FontWeight', 'bold', ...
	'BackgroundColor', [0.7 0.7 0.7], ...
	'String', 'Regular grid');

handles.txtAveragingScn = uicontrol(	'Parent', handles.uipanelMapData, ...
	'Tag', 'txtAveragingScn', ...
	'UserData', zeros(1,0), ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [79.8 6.6 23.6 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.7 0.7 0.7], ...
	'String', 'Averaging section width');

handles.txtGuiTitle = uicontrol(	'Parent', handles.figGridData, ...
	'Tag', 'txtGuiTitle', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [43.1 24.9 43.5 1.9], ...
	'FontName', 'Helvetica', ...
	'FontSize', 18, ...
	'FontWeight', 'bold', ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Mapping data to grid');

handles.txt2ndAxis = uicontrol(	'Parent', handles.uipanelMapData, ...
	'Tag', 'txt2ndAxis', ...
	'UserData', zeros(1,0), ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [3.1 1.5 10.1 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.7 0.7 0.7], ...
	'String', '2nd axis', ...
	'HorizontalAlignment', 'left');

handles.txtDatasetForGridding = uicontrol(	'Parent', handles.figGridData, ...
	'Tag', 'txtDatasetForGridding', ...
	'UserData', zeros(1,0), ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [3.1 21.5 23.5 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Dataset to be handled');

% --- PUSHBUTTONS -------------------------------------
handles.pushBtnGrid = uicontrol(	'Parent', handles.figGridData, ...
	'Tag', 'pushBtnGrid', ...
	'UserData', [], ...
	'Style', 'pushbutton', ...
	'Units', 'characters', ...
	'Position', [73.1 1.6 13.5 1.9], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'FontWeight', 'bold', ...
	'String', 'Map data', ...
	'Callback', @pushBtnGrid_Callback);

handles.pushBtnClose = uicontrol(	'Parent', handles.figGridData, ...
	'Tag', 'pushBtnClose', ...
	'UserData', [], ...
	'Style', 'pushbutton', ...
	'Units', 'characters', ...
	'Position', [93.1 1.6 10.1 1.9], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'FontWeight', 'bold', ...
	'String', 'Close', ...
	'Callback', @pushBtnClose_Callback);

handles.pushEstimateGrid = uicontrol(	'Parent', handles.figGridData, ...
	'Tag', 'pushEstimateGrid', ...
	'UserData', [], ...
	'Style', 'pushbutton', ...
	'Units', 'characters', ...
	'Position', [41.1 1.5 28.8 2], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'FontWeight', 'bold', ...
	'String', 'Estimate grid parameters', ...
	'Callback', @pushEstimateGrid_Callback);

% --- EDIT TEXTS -------------------------------------
handles.editGrid2ndAxis = uicontrol(	'Parent', handles.uipanelMapData, ...
	'Tag', 'editGrid2ndAxis', ...
	'UserData', zeros(1,0), ...
	'Style', 'edit', ...
	'Units', 'characters', ...
	'Position', [39.8 1.5 38.1 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 10, ...
	'BackgroundColor', [1 1 1], ...
	'String', strGrid2ndAxis, ...
	'Callback', @editGrid2ndAxis_Callback, ...
	'CreateFcn', @editGrid2ndAxis_CreateFcn);

handles.editAverWidth1stAxis = uicontrol(	'Parent', handles.uipanelMapData, ...
	'Tag', 'editAverWidth1stAxis', ...
	'UserData', zeros(1,0), ...
	'Style', 'edit', ...
	'Units', 'characters', ...
	'Position', [86.5 4.9 10.1 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 10, ...
	'BackgroundColor', [1 1 1], ...
	'String', strAverWidth1stAxis, ...
	'HorizontalAlignment', 'right', ...
	'Callback', @editAverWidth1stAxis_Callback, ...
	'CreateFcn', @editAverWidth1stAxis_CreateFcn);

handles.editAverWidth2ndAxis = uicontrol(	'Parent', handles.uipanelMapData, ...
	'Tag', 'editAverWidth2ndAxis', ...
	'UserData', zeros(1,0), ...
	'Style', 'edit', ...
	'Units', 'characters', ...
	'Position', [86.5 1.5 10.1 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 10, ...
	'BackgroundColor', [1 1 1], ...
	'String', strAverWidth2ndAxis, ...
	'HorizontalAlignment', 'right', ...
	'Callback', @editAverWidth2ndAxis_Callback, ...
	'CreateFcn', @editAverWidth2ndAxis_CreateFcn);

handles.editGrid1stAxis = uicontrol(	'Parent', handles.uipanelMapData, ...
	'Tag', 'editGrid1stAxis', ...
	'UserData', zeros(1,0), ...
	'Style', 'edit', ...
	'Units', 'characters', ...
	'Position', [39.8 4.9 38.1 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 10, ...
	'BackgroundColor', [1 1 1], ...
	'String', strGrid1stAxis, ...
	'Callback', @editGrid1stAxis_Callback, ...
	'CreateFcn', @editGrid1stAxis_CreateFcn);

% --- POPUP MENU -------------------------------------
handles.popDataset = uicontrol(	'Parent', handles.figGridData, ...
	'Tag', 'popDataset', ...
	'UserData', [], ...
	'Style', 'popupmenu', ...
	'Units', 'characters', ...
	'Position', [26.5 21.5 23.5 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', {'Listbox'}, ...
	'Callback', @popDataset_Callback, ...
	'CreateFcn', @popDataset_CreateFcn);

handles.popDataField = uicontrol(	'Parent', handles.figGridData, ...
	'Tag', 'popDataField', ...
	'UserData', zeros(1,0), ...
	'Style', 'popupmenu', ...
	'Units', 'characters', ...
	'Position', [20 4.8 23.5 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', {'Listbox'}, ...
	'Callback', @popDataField_Callback, ...
	'CreateFcn', @popDataField_CreateFcn);

handles.popVar1stAxis = uicontrol(	'Parent', handles.uipanelMapData, ...
	'Tag', 'popVar1stAxis', ...
	'UserData', zeros(1,0), ...
	'Style', 'popupmenu', ...
	'Units', 'characters', ...
	'Position', [13.1 4.9 23.5 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', {'Listbox'}, ...
	'Callback', @popVar1stAxis_Callback, ...
	'CreateFcn', @popVar1stAxis_CreateFcn);

handles.popVar2ndAxis = uicontrol(	'Parent', handles.uipanelMapData, ...
	'Tag', 'popVar2ndAxis', ...
	'UserData', zeros(1,0), ...
	'Style', 'popupmenu', ...
	'Units', 'characters', ...
	'Position', [13.1 1.5 23.5 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', {'Listbox'}, ...
	'Callback', @popVar2ndAxis_Callback, ...
	'CreateFcn', @popVar2ndAxis_CreateFcn);

% Save handles structure
guidata(handles.figGridData,handles);

set(handles.txtDataToGrid,'ToolTipString','Suggested PSD or PSDNorm');
set(handles.txt1stAxis,'ToolTipString','Suggested Qx, Qy or Qz');
set(handles.txt2ndAxis,'ToolTipString','Suggested Qx, Qy or Qz');

% Assign function output
fig_hdl = handles.figGridData;
% Scale size to fit the text in
%objFieldnames=fieldnames(handles);
%for ii=1:length(objFieldnames),
%	curPos=get(handles.(objFieldnames{ii}),'Position');
%	newPos=curPos*scalingFact;
%	set(handles.(objFieldnames{ii}),'Position',newPos);
%end;
% Move gui to center, make visible
movegui(fig_hdl,'center');
set(fig_hdl,'visible','on');
else
figure(fig_hdl);
end;

%-------------------------------------------------------------------------------
	function pushBtnGrid_Callback(hObject,evendata)
		% Variables
		strGrid1stAxis=get(handles.editGrid1stAxis,'String');
		strGrid2ndAxis=get(handles.editGrid2ndAxis,'String');
		strAverWidth1stAxis=get(handles.editAverWidth1stAxis,'String');
		strAverWidth2ndAxis=get(handles.editAverWidth2ndAxis,'String');
		Q1g=eval(strGrid1stAxis);
		Q2g=eval(strGrid2ndAxis);
		delQ1=str2num(strAverWidth1stAxis);
		delQ2=str2num(strAverWidth2ndAxis);
		Q3g=0;
		delQ3=1;
		scn=0; % Initializtion of the variable
		
		% Collect data needed
		MSpScn=getPopCurStr(handles.popDataset);
		StrAx1Field=getPopCurStr(handles.popVar1stAxis); % Field with 1st axis
		StrAx2Field=getPopCurStr(handles.popVar2ndAxis); % 2nd axis
		StrDataField=getPopCurStr(handles.popDataField);

		cmd=['scn=',MSpScn,';'];
		eval(cmd);
		Q1=scn.(StrAx1Field);
		Q2=scn.(StrAx2Field);
		Q3=zeros(size(Q1));
		Data=scn.(StrDataField);
		
		% Data gridding
		DataG=gridq1_01(Q1g,Q2g,Q3g,Data(:),Q1(:),...
			Q2(:),Q3(:),delQ1,delQ2,delQ3,'mean');
		DataG=reshape(DataG,length(Q1g),length(Q2g),length(Q3g));
		DataG=squeeze(DataG)';
		% Returning values
		scn=setfield(scn, [StrDataField,'g'],DataG);
		scn=setfield(scn, [StrAx1Field,'g'],Q1g);
		scn=setfield(scn, [StrAx2Field,'g'],Q2g);
		cmd=[MSpScn,'=scn;'];
		eval(cmd);
		set(hndMainGUI,'Visible','On');
		hmsg=msgbox(['Data were successfully mapped. Resulting varialbes ',...
			sprintf('%sg, %sg, and %sg ',StrAx1Field,StrAx2Field,...
			StrDataField),...
			'were added to dataset ', MSpScn,'.'],'MatSpec','modal');
		close(fig_hdl);
	end

%-------------------------------------------------------------------------------
	function pushBtnClose_Callback(hObject,evendata)
		set(hndMainGUI,'Visible','On');
		delete(fig_hdl);
	end

%-------------------------------------------------------------------------------
	function pushEstimateGrid_Callback(hObject,evendata)
		MSpScn=getPopCurStr(handles.popDataset);
		StrAx1Field=getPopCurStr(handles.popVar1stAxis); % Field with 1st axis
		StrAx2Field=getPopCurStr(handles.popVar2ndAxis); % 2nd axis

		cmd=['scn=',MSpScn,';'];
		eval(cmd);
		Q1=scn.(StrAx1Field);
		Q2=scn.(StrAx2Field);
	
		[Q1r,Q1d]=detDimRang(Q1);
		[Q2r,Q2d]=detDimRang(Q2);
		% Multiplication constants for step and binning
		stepC=1.2; binC=1.5;
		% Q1: ranges and binning 
		myStr=sprintf('[%g:%g:%g]', Q1r(1), stepC*Q1d, Q1r(2));
		set(handles.editGrid1stAxis,'String',myStr);
		myStr=sprintf('%g', binC*Q1d);
		set(handles.editAverWidth1stAxis,'String',myStr);
		% Q2: ranges and binning 
		myStr=sprintf('[%g:%g:%g]', Q2r(1), stepC*Q2d, Q2r(2));
		set(handles.editGrid2ndAxis,'String',myStr);
		myStr=sprintf('%g', binC*Q2d);
		set(handles.editAverWidth2ndAxis,'String',myStr);

		% Retrive parameters

	end

%-------------------------------------------------------------------------------
	function editGrid2ndAxis_Callback(hObject,evendata)
		strGrid2ndAxis=get(handles.editGrid2ndAxis,'String');
	end

%-------------------------------------------------------------------------------
	function editGrid2ndAxis_CreateFcn(hObject,evendata)
		
	end

%-------------------------------------------------------------------------------
	function editAverWidth1stAxis_Callback(hObject,evendata)
		strAverWidth1stAxis=get(handles.editAverWidth1stAxis,'String');
	end

%-------------------------------------------------------------------------------
	function editAverWidth1stAxis_CreateFcn(hObject,evendata)

	end

%-------------------------------------------------------------------------------
	function editAverWidth2ndAxis_Callback(hObject,evendata)
		strAverWidth2ndAxis=get(handles.editAverWidth2ndAxis,'String');
	end

%-------------------------------------------------------------------------------
	function editAverWidth2ndAxis_CreateFcn(hObject,evendata)

	end

%-------------------------------------------------------------------------------
	function editGrid1stAxis_Callback(hObject,evendata)
		strGrid1stAxis=get(handles.editGrid1stAxis,'String');
	end

%-------------------------------------------------------------------------------
	function editGrid1stAxis_CreateFcn(hObject,evendata)

	end

%-------------------------------------------------------------------------------
	function popDataset_Callback(hObject,evendata)
		MSpScn=getPopCurStr(handles.popDataset);
		myFieldNames=retrieveDataFields;
		setPopFieldNames(handles.popDataField,myFieldNames,ValPopDataField);
		setPopFieldNames(handles.popVar1stAxis,myFieldNames,ValPopVar1stAxis);
		setPopFieldNames(handles.popVar2ndAxis,myFieldNames,ValPopVar2ndAxis);
	end

%-------------------------------------------------------------------------------
	function popDataset_CreateFcn(hObject,evendata)
		if (~isempty(MSpScn) && ~isempty(MSpScnList)),
				ii=find(strcmp(MSpScn,MSpScnList),1);
				set(hObject,'String',MSpScnList,'Value', ii);
		elseif length(MSpScnList)>0,
				set(handles.popDataset,'String',MSpScnList,'Value', 1);
		else
				set(hObject,'String',{'------'});
		end;
	end

%-------------------------------------------------------------------------------
	function popDataField_Callback(hObject,evendata)
		ValPopDataField=get(handles.popDataField,'Value');
		strs=get(handles.popDataField,'String');
		str=strs{ValPopDataField};
		set(handles.txtOutVarData,'String',[str,'g']);
	end

%-------------------------------------------------------------------------------
	function popDataField_CreateFcn(hObject,evendata)
		myFieldNames=retrieveDataFields;
		ValPopDataField=setPopFieldNames(hObject,myFieldNames,ValPopDataField);
		strs=get(hObject,'String');
		str=strs{ValPopDataField};
		set(handles.txtOutVarData,'String',[str,'g']);
	end

%-------------------------------------------------------------------------------
	function popVar1stAxis_Callback(hObject,evendata)
		ValPopVar1stAxis=get(handles.popVar1stAxis,'Value');
		strs=get(handles.popVar1stAxis,'String');
		str=strs{ValPopVar1stAxis};
		set(handles.txtOutVar1,'String',[str,'g']);
	end

%-------------------------------------------------------------------------------
	function popVar1stAxis_CreateFcn(hObject,evendata)
		myFieldNames=retrieveDataFields;
		ValPopVar1stAxis=setPopFieldNames(hObject,myFieldNames,ValPopVar1stAxis);
		strs=get(hObject,'String');
		str=strs{ValPopVar1stAxis};
		set(handles.txtOutVar1,'String',[str,'g']);
	end

%-------------------------------------------------------------------------------
	function popVar2ndAxis_Callback(hObject,evendata)
		ValPopVar2ndAxis=get(handles.popVar2ndAxis,'Value');
		strs=get(handles.popVar2ndAxis,'String');
		str=strs{ValPopVar2ndAxis};
		set(handles.txtOutVar2,'String',[str,'g']);
	end

%-------------------------------------------------------------------------------
	function popVar2ndAxis_CreateFcn(hObject,evendata)
		myFieldNames=retrieveDataFields;
		ValPopVar2ndAxis=setPopFieldNames(hObject,myFieldNames,ValPopVar2ndAxis);
		strs=get(hObject,'String');
		str=strs{ValPopVar2ndAxis};
		set(handles.txtOutVar2,'String',[str,'g']);
	end

%-------------------------------------------------------------------------------

function closeIt(gcbf,ar2);
set(hndMainGUI,'Visible','On');
delete(fig_hdl);
end;
%-------------------------------------------------------------------------------
	function myFieldNames=retrieveDataFields;
		% retrieve fields of the dataset
		myFieldNames={};
		flgIsStruct=0;
		if ~isempty(MSpScn),
				if  iscell(MSpScn),
						MSpScn=MSpScn{1};
				end;
				cmd=['flgIsStruct=isstruct(', MSpScn,');'];
				eval(cmd);
				if flgIsStruct,
						cmd=['myFieldNames=fieldnames(',MSpScn,');'];
						eval(cmd);
				else
						myFieldNames={};
				end;
		else,
				myFieldNames={};
		end;
	end;
	
	function val1=setPopFieldNames( hndl, str, val),
		% Set popup menu field names and the current filed (val)
		% hndl ... handle to the popup menu
		% str ... string
		% val ... value
		if (isempty(str)),
			lstr=1;
			str={'------'};
		else if (iscell(str)),
			lstr=length(str);
		else
			lstr=1;
		end;
		end;

		if (val>lstr),
			val=1;
		end;
		
		set(hndl,'String',str);
		set(hndl,'Value',val);
		val1=val;
	end;

	function str=getPopCurStr(hndl),
		strs=get(hndl,'String');
		ii=get(hndl,'Value');
		str=strs{ii};
	end;

	function mmi=meanmin(m)
		mmi=mean(min(m));
	end;

	function mma=meanmax(m)
		mma=mean(max(m));
	end;

	function meandel=meandif(m)
		meandel=mean( mean( abs( diff(m))));
	end;

	function [sugQ,sugDel,dir]=detDimRang(m),
	% sugQ=[Qmin,Qmax] ... suggested ranges
	% dir ... dominant direction of the change of M, 1... along columns,
	%			... 2 along rows
		mmiv=meanmin(m); mmav=meanmax(m);
		mmih=meanmin(m'); mmah=meanmax(m');
		delv=mmav-mmiv; delh=mmah-mmih;
		sugQ=[0,0];
		if delv>delh,
			sugQ(1)=mmiv-std(min(m)); 
			sugQ(2)=mmav+std(max(m)); 
			dir=1;
			sugDel=meandif(m);
		else
			sugQ(1)=mmih-std(min(m')); 
			sugQ(2)=mmah+std(max(m')); 
			dir=2;
			sugDel=meandif(m');
		end;
		sugQ=rounddef(sugQ,3);
		sugDel=rounddef(sugDel,2);
	end;
	
	function y=rounddef(x,n);
		% function rounddef(x,n);
		% rounds x to n decimal places
		sg=sign(x);
		ind=find(sg~=0);
		lx=ceil(log10(abs(x(ind))))-n;
		dlx=10.^lx;
		y=zeros(size(x));
		y(ind)=round(x(ind)./dlx).*dlx;
	end

end
