function [TFuncNames,TFArgs,TFComments]=MSpGUIReadA2QCfg(fname);
% Read configuration file for Ang2Q menu
% Input: fname ... name of config file (or path/filename)
% TFuncNames ... cell array of names of functions
% TFArgs ... cell array of cell arrays with names of function arguments
% TFComments ... cell array of strings

% Open file
FidCfg=fopen(fname,'r');
% go to beginning of the file
fseek(FidCfg,0,-1);
% Read data to a string tdat
dat=fread(FidCfg,inf,'uchar=>uchar');
fclose(FidCfg);
tdat=char(dat');
% Get positions of heads
[shF,ehF]=headpos(tdat,'#F');
[shA,ehA]=headpos(tdat,'#A');
[shC,ehC]=headpos(tdat,'#C');
nn=length(shF);
TFuncNames=cell(nn,1);
for ii=1:nn,
	tmp=SpPurifyHeadChunk2(tdat(shF(ii):ehF(ii)),'#F\s*','\n');
	ind=regexp(tmp,'^[ ]');
	tmp(ind)=[];
	TFuncNames{ii}=deblank(tmp);
end;
nn=length(shA);
TFArgs=cell(nn,1);
for ii=1:nn,
	tmp=SpPurifyHeadChunk2(tdat(shA(ii):ehA(ii)),'#A\s*','\n');
	ind=regexp(tmp,'^[ ]');
	tmp(ind)=[];
	ind=regexp(tmp,'(\n[ ])');
	tmp(ind+1)=[];
	TFArgs{ii}=SpStr2cell(tmp);
end;
nn=length(shC);
TFComments=cell(nn,1);
for ii=1:nn,
	tmp=tdat(shC(ii):ehC(ii));
	ind=findstr(tmp,'#C');
	while ~isempty(ind),
		tmp([0:1]+ind(1))=[];
		ind=findstr(tmp,'#C');
	end;
	ind=regexp(tmp,'\r');
	tmp(ind)=[];
	ind=regexp(tmp,'(^[ ])');
	tmp(ind)=[];
	ind=regexp(tmp,'(\n[ ])');
	tmp(ind+1)=[];
	TFComments{ii}=tmp;
end;

%....
% get filename ii
%tmp=tdat(shF(ii):ehF(ii));
%FNameTrans{ii}=tmp(4:end);

% For #A lines one can use this function
%c=SpStr2cell(line#A);
%TransformParams{ii}=c;


function [hs,hf]=headpos(tdat,HeadType);
% Finds beginnings and ends of continues scan heads
% Find limits of head lines
[hs,hf]=regexp(tdat,[HeadType,'[^\n]*']);
% Where head continues on the next line?
df=hs(2:end)-hf(1:end-1)-2;
ind=find(df==0);
hs(ind+1)=[];
hf(ind)=[];
hf=hf+1;
ind=find(hf>length(tdat));
while ~isempty(ind),
	hf(ind)=hf(ind)-1;
	ind=find(hf>length(tdat));
end;

