%MSpScanLiquidA2GUI


disp('MSpScanLiquidA2GUI called....');

flgUnspec=1; % Extract data from a SPEC file to Matlab
flgNormalize=1; % Normalize intensities for monitor and absorbers 
flgAng2Q=0; % Transform from the angular space to the reciprocal space
flgPlotPSD=1; % Plot rough PSD spectra
flgAutoGridEst=0; % Should I perform automatic estimation of the density
flgGridQ=0;	% Perform gridding (mapping of data in Q space from unevenly	
flgPlotGrid=0; % Plot data in Q space (gridded data) 
flgPrintPlot=0; % Print plot currently plotted to a pdf file
flgSaveMat=0; % Save the scan data to a mat file (matlab native format)
flgLoadMat=0; % Load the scan data from a mat file previously saved		
flgSaveAscii=0; % Export data into ASCII files 

%% Choices:
SpecName='MSpScanLiquidA.spec';
scn='s18';	
scNum=[18]; 
MotDetOff={'delta',0,'gamma',44.7};
NameDet={'all0','PSD'};
NameAtt='curratt';
NameMon='Monitor';
MonNorm=1e5;
NormFac=3.892; % Attenuation factor for one filter 
lambda=1.55; % 8 keV

Ang2Q={'MSpAng2Q1v2','mu','delta','gamma'};

%%  For ID10B ESRF: 
c0=541;
cpd=268.4;
ROI=[58,960];

%% Part: Gridding of the intensity
Qxg=[-0.0010]; delQx=0.005;
Qyg=[-0.0424:0.0009:-0.002]; delQy=0.0014;
Qzg=[-0.1244:0.0004:0.113236]; delQz=0.0006;

%% Part: The 2D plot:
xGridField='Qyg';
yGridField='Qzg';
colorGridField='PSDNormg'; % Which variable is colorscaled (z-variable)

%% PSD plot (rough data plotting = a motor on x-axis, channel number on the y-axis)
PSDPlotXField='delta'; % variable on the x-axis of the 2D plot
PSDPlotPSD='PSDNorm'; % which variable is colorscaled (z-variable)
%% Plot of the gridded data
flgIntLog=1; % Plot intensity logarithmically? 0/1=no/yes
truncLogBot=0; % Maximum of log10(intensity) which will be colorscaled
truncLogTop=0.0; % Minimum of log10(intensity) which will be colorscaled
AxFontSize=12;
LabelFontSize=12;
FName='MSpScanLiquidA';
PrintFormat='jpeg'; 
SaveASCII_Vars={'delta','channs','PSDNorm'};




