 %NormalizeIntensities.m
 
function NormalizeIntensities

global MSpScnList  MSpf  MSpScn;
flgIsStruct=0;
if ~isempty(MSpScnList),
	n=length(MSpScnList );
	for ii = 1:n
		cmd=['global ', MSpScnList{ii}];
		eval(cmd);
	end;
end;
persistent CurrAttFacStr
if isempty(CurrAttFacStr),
	CurrAttFacStr=1;
end;
 
f0=figure('Visible','off',...
	'MenuBar', 'none', ...
'Position',[50,50,420,300]);
set(f0,'Name','Normalize Intensities','CloseRequestFcn',{@closeMnu});
set(f0,'tag','NormalizeIntensities');
set(f0,'Visible','on');
hndMainGUI=findobj('Tag','figGUIMatSpec');
set(hndMainGUI,'Visible','Off');

hlbNormalizeIntensities = uicontrol('Style','text','FontSize',16,'String','Normalize Intensities','Position',[20,260,380,30]);
str0 = 'Normalization is done as: ';
str1 = 'intensity_normalized=(intensity_behind_sample/monitor*norm_factor)';
strNI=[str0,str1];
set(hlbNormalizeIntensities ,'ToolTipString',strNI);


hlbDataSet2WorkOn = uicontrol('Style','text','String','Dataset to work on:','Position',[20,220,280,20]);
% Dataset menu
hpopDataSet2WorkOn = uicontrol('Style','popupmenu','String',MSpScnList ,'Position',[280,220,100,20],'Callback',{@popDataSet2WorkOn_Callback});
if (~isempty(MSpScn) && ~isempty(MSpScnList)),
    ii=find(strcmp(MSpScn,MSpScnList),1);
    set(hpopDataSet2WorkOn,'Value',ii);
end;
% Detector menu
    % retrive fields of the dataset
if ~isempty(MSpScn),
    cmd=['flgIsStruct=isstruct(', MSpScn,');'];
    eval(cmd);
    if flgIsStruct,
        cmd=['myFieldNames=fieldnames(',MSpScn,');'];
        eval(cmd);
    else
        myFieldNames={}
    end;
else,
    myFieldNames={}
end;


%NAME OF DETECTOR TO BE NORMALIZED
persistent valNameDet;
if isempty(valNameDet),
	valNameDet=1;
end;
hlbNameOfDetectorToBeNormalized = uicontrol('Style','text','String','Name Of Detector To Be Normalized:','Position',[20,180,280,20]);
hpopNameOfDetectorToBeNormalized = uicontrol('Style','popupmenu','String',myFieldNames,'Value',valNameDet,'Position',[280,180,100,20]);
str0=['Detector measuring scattered intensity (i.e. detector ',...
	'behind the sample)'];
set(hpopNameOfDetectorToBeNormalized ,'ToolTipString',str0,'Callback',{@popNameOfDetectorToBeNormalized_Callback});

%NAME OF MONITOR
persistent valNameMon;
if isempty(valNameMon),
	valNameMon=1;
end;
hlbNameOfMonitor = uicontrol('Style','text','String','Name of Monitor','Position',[20,140,280,20]);
hpopNameOfMonitor = uicontrol('Style','popupmenu','String',myFieldNames,'Value',valNameMon,'Position',[280,140,100,20],'Callback',{@popNameOfMonitor_Callback});

%NAME ATTENUATION MONITOR
persistent valNameAtt;
if isempty(valNameAtt),
	valNameAtt=1;
end;
hlbNameAttenuatorMotor = uicontrol('Style','text','String','Name Attenuation motor','Position',[20,100,280,20]);
hpopNameAttenuatorMotor = uicontrol('Style','popupmenu','String',myFieldNames,'Value',valNameAtt,'Position',[280,100,100,20],'Callback',{@popNameAttenuatorMotor_Callback});

%ATTENUATION FACTOR
hLbAttenuationFactor = uicontrol('Style','text','String','Attenuation Factor:','Position',[20,60,140,20]);
hEdAttenuationFactor = uicontrol('Style','edit','String',CurrAttFacStr,'Position',[160,60,40,20]);

%NORMALIZATION FACTOR
hLbNormalizationFactor = uicontrol('Style','text','String','Normalization Factor:','Position',[200,60,140,20]);
hEdNormalizationFactor = uicontrol('Style','edit','String','1e5','Position',[340,60,40,20]);

hBtClose=uicontrol('Style','pushbutton','String','Close','Position',[280,20,100,20],'Callback',{@close_Callback});
hEdPSDNorm = uicontrol('Style','edit','String','-','Position',[120,20,80,20]);
hBtNormalize=uicontrol('Style','pushbutton','String','Normalize','Position',[20,20,100,20],'Callback',{@normalize_Callback});


function popDataSet2WorkOn_Callback(source, eventdata)
end

function popNameOfDetectorToBeNormalized_Callback(source, eventdata)
    str=get(hpopNameOfDetectorToBeNormalized,'String');
    val=get(hpopNameOfDetectorToBeNormalized,'Value');
    NameDet=str{val};
    set(hEdPSDNorm,'String',[NameDet,'Norm']);
end

function popNameOfMonitor_Callback(source, eventdata)
end

function popNameAttenuatorMotor_Callback(source, eventdata)
end

function normalize_Callback(hObject,eventdata)
	str=get(hpopDataSet2WorkOn,'String');
  valMSpScnList=get(hpopDataSet2WorkOn,'Value');
  MSpScn=str{valMSpScnList};
	  
	str=get(hpopNameOfDetectorToBeNormalized,'String');
	valNameDet=get(hpopNameOfDetectorToBeNormalized,'Value');
	NameDet=str(valNameDet);
	 
	str=get(hpopNameOfMonitor,'String');
	valNameMon=get(hpopNameOfMonitor,'Value');
	NameMon=str{valNameMon};
	 
	str=get(hpopNameAttenuatorMotor,'String');
	valNameAtt=get(hpopNameAttenuatorMotor,'Value');
	NameAtt=str{valNameAtt};
	 
  str0= get(hEdAttenuationFactor,'String');
  AttFac=str2num(str0);
	
  str0= get(hEdNormalizationFactor,'String');
  MonNorm=str2num(str0);
    
  cmd=[MSpScn,'=','MSpNormalize2(',MSpScn,...
		',AttFac,NameAtt,NameDet,','NameMon,MonNorm);'];
  eval(cmd);
	txt=sprintf(['Normalized intenisity was stored',...
		' in variable: %s'], [NameDet{:},'Norm']);
  msgbox(txt);
end

function close_Callback(hObject,eventdata)
	CurrAttFacStr=get( hEdAttenuationFactor, 'string');
	valNameDet=get(hpopNameOfDetectorToBeNormalized,'Value');
	valNameMon=get(hpopNameOfMonitor,'Value');
	valNameAtt=get(hpopNameAttenuatorMotor,'Value');
	close(f0);
end

function closeMnu(source, eventdata),
	CurrAttFacStr=get( hEdAttenuationFactor, 'string');
	valNameDet=get(hpopNameOfDetectorToBeNormalized,'Value');
	valNameMon=get(hpopNameOfMonitor,'Value');
	valNameAtt=get(hpopNameAttenuatorMotor,'Value');
	set(hndMainGUI,'Visible','On');
	delete(f0);
end;

end
 
 
 

