 %PlotRoughData.m
 
function PlotRoughData

global MSpScnList MSpf  MSpScn ImgFormatList;
% global for this Menu
global PSDPlotXField PSDPlotPSD PrintFormat FName
global flgIntLog flgPrintPlot min_Ivalue max_Ivalue;
global min_I max_I;
 % Make datasets known here
 if ~isempty(MSpScnList),
    n=length(MSpScnList );
    for ii = 1:n
        cmd=['global ', MSpScnList{ii}];
        eval(cmd);
    end;
 end;
% Test min,max of intensity from previous sessions of this menu
 if isempty(min_Ivalue),
    min_Ivalue='1e-16';
  end;
  if isempty(max_Ivalue),
      max_Ivalue='1e16';
  end;
 
f0=figure('Visible','off',...
	'MenuBar', 'none', ...
'Position',[50,50,520,300]);
set(f0,'Name','Plot Rough Data',...
	'CloseRequestFcn',{@closeIt});
set(f0,'Visible','on');
hndMainGUI=findobj('Tag','figGUIMatSpec');
set(hndMainGUI,'Visible','Off');

%PLOT ROUGH DATA
hlbPlotRoughData = uicontrol('Style','text','FontSize',16,'String','Plot Rough Data','Position',[20,260,380,30]);
str0 = 'Plots PSD Data ';
str1 = 'as function of an angle';
strNI=[str0,str1];
set(hlbPlotRoughData ,'ToolTipString',strNI);

%DATASET TO BE PLOTTED
hlbDataSet2BePlotted = uicontrol('Style','text','String','Dataset to be plotted:','Position',[20,230,160,20]);
hpopDataSet2BePlotted = uicontrol('Style','popupmenu','Position',...
	[180,230,100,20],'Callback',{@popDataSet2BePlotted_Callback});
if (~isempty(MSpScn) && ~isempty(MSpScnList)),
    ii=find(strcmp(MSpScn,MSpScnList),1);
    set(hpopDataSet2BePlotted,'String',MSpScnList,'Value', ii);
elseif length(MSpScnList)>0,
    set(hpopDataSet2BePlotted,'String',MSpScnList,'Value', 1);
else
    set(hpopDataSet2BePlotted,'String','------');
end;


%MOTOR ON X-AXIS
persistent valPSDPlotXField;
if isempty( valPSDPlotXField),
       valPSDPlotXField=1;
end;
% retrive fields of the dataset
flgIsStruct=0;
if ~isempty(MSpScn),
    if  iscell(MSpScn),
        MSpScn=MSpScn{1};
    end;
    cmd=['flgIsStruct=isstruct(', MSpScn,');'];
    eval(cmd);
    if flgIsStruct,
        cmd=['myFieldNames=fieldnames(',MSpScn,');'];
        eval(cmd);
    else
        myFieldNames={};
    end;
else,
    myFieldNames={};
end;

hlbMotorOnXAxis = uicontrol('Style','text','String','Motor On X-Axis:','Position',[20,200,160,20]);
hpopMotorOnXAxis  = uicontrol('Style','popupmenu',...
	'Position',[180,200,100,20],'Callback',{@popMotorOnXAxis_Callback});
if ~isempty(MSpScn),
    if length(myFieldNames)>=valPSDPlotXField,
        set(hpopMotorOnXAxis,'String',myFieldNames,'Value',...
					valPSDPlotXField);
    else
        set(hpopMotorOnXAxis,'String',myFieldNames,'Value', 1);
     end;
else
    set(hpopMotorOnXAxis,'String','----');
end;
str0='Motor On X-Axis ';
set(hpopMotorOnXAxis ,'ToolTipString',str0,'Callback',{@popMotorOnXAxis_Callback});


%NAME VARIABLE WITH PSD DATA
persistent valPSDPlotPSD;
if isempty( valPSDPlotPSD),
	 valPSDPlotPSD=1;
end;
hlbNameVariableWithPSDData = uicontrol('Style','text','String','Name Variable with PSD Data','Position',[20,170,160,20]);
hpopNameVariableWithPSDData = uicontrol('Style','popupmenu',...
	'Position',[180,170,100,20],'Callback',...
	{@popNameVariableWithPSDData_Callback});

hfrNameVariableWithPSDData = uicontrol('Style','frame','String','66666?','Position',[300,140,200,80]);

hlbLimitsColorScaledIntensity = uicontrol('Style','text','String','Limits color-scale intensity:','Position',[310,190,180,20]);
initial_value='0.0';
hlbMaxIntensity = uicontrol('Style','text','String','Max:','Position',[410,170,40,20]);
if isempty(min_Ivalue),
	min_Ivalue=1e-16;
end;
if isempty(max_Ivalue),
	max_Ivalue=5000;
end;
if isempty(min_I),
	 max_I=min_Ivalue;
end;
if isempty(max_I),
	 max_I=max_Ivalue;
end;
hlbMaxIVal = uicontrol('Style','text','String',num2str(max_Ivalue),'Position',[450,170,40,20]);
hedMaxIntensity =uicontrol('Style','edit',...
	'String',num2str(max_I),...
	'Position',[410,150,80,20]);

hlbMinIntensity = uicontrol('Style','text','String','Min:','Position',[310,170,40,20]);
hlbMinIVal = uicontrol('Style','text','String',num2str(min_Ivalue),...
	'Position',[350,170,40,20]);
hedMinIntensity =...
	uicontrol('Style','edit','String',num2str(min_I),...
	'Position',[310,150,80,20]);

if  ~isempty(MSpScn),
    if length(myFieldNames)>=valPSDPlotPSD,
        set(hpopNameVariableWithPSDData,'String',...
					myFieldNames,'Value', valPSDPlotPSD);
     else,
        set(hpopNameVariableWithPSDData,'String',...
					myFieldNames,'Value',1);
     end;
else,
    set(hpopNameVariableWithPSDData,'String','----');
end;

%PLOT INTENSITY IN LOG SCALE
if isempty(flgIntLog),
       flgIntLog=1;
end;
hcheckPLotIntensityLogScale = uicontrol('Style','checkbox',...
	'String','Plot Intensity in Log Scale?',...
	'Position',[20,140,180,20],'Callback',...
	{@checkPLotIntensityLogScale_Callback});
set(hcheckPLotIntensityLogScale,'Value',flgIntLog);

%PRINT TO FILE
 if isempty(flgPrintPlot),
       flgPrintPlot=0;
end;
hfrOptions= uicontrol('Style','frame','String','Print to File?','Position',[20,60,480,70]);
hcheckPrintToFile = uicontrol('Style','checkbox','String','Print to File?','Position',[40,100,100,20],'Callback',{@checkPrintToFile_Callback});
set(hcheckPrintToFile,'Value',flgPrintPlot);
%IMAGE FORMAT
persistent valPrintFormat;
 if isempty( valPrintFormat),
       valPrintFormat=1;
end;
ImgFormatList={'eps','ps','jpeg','png','pdf'};
hlbImageFormat = uicontrol('Style','text','String','Image Format: ','Position',[140,100,100,20]);
hpopImageFormat = uicontrol('Style','popupmenu','String',ImgFormatList,'Position',[260,100,100,20],'Callback',{@popImageFormat_Callback});
set(hpopImageFormat,'Value',valPrintFormat);


%FILE NAME
if ~exist('FName') || isempty(FName),
    FName=MSpScn;
end;
hlbFileName= uicontrol('Style','text','String','File Name: ','Position',[160,70,60,20]);
hedFileName = uicontrol('Style','edit','String',FName,'Position',[100,70,140,20]);
hbtFileName=uicontrol('Style','pushbutton','String','Browse','Position',[260,70,100,20],'Callback',{@btFileName_Callback});

%PLOT
hpbPlot = uicontrol('Style','pushbutton','String','PLOT','Position',[140,20,100,20],'Callback',{@pbPlot_Callback});
hpbClose = uicontrol('Style','pushbutton','String','CLOSE','Position',[240,20,100,20],'Callback',{@pbClose_Callback});


%CALLBACKS CALLBACKS CALLBACKS CALLBACKS CALLBACKS CALLBACKS CALLBACKS
%CALLBACKS CALLBACKS CALLBACKS CALLBACKS CALLBACKS CALLBACKS CALLBACKS 

%DATASET TO BE PLOTTED
function popDataSet2BePlotted_Callback(source, eventdata)
    str=get(hpopDataSet2BePlotted,'String');
    val=get(hpopDataSet2BePlotted,'Value');
    MSpScn=str{val};
    
    % retrive fields of the dataset
    flgIsStruct=0;
    if ~isempty(MSpScn),
        cmd=['flgIsStruct=isstruct(', MSpScn,');'];
        eval(cmd);
        if flgIsStruct,
            cmd=['myFieldNames=fieldnames(',MSpScn,');'];
            eval(cmd);
        else
            myFieldNames={};
        end;
    else,
        myFieldNames={};
    end;

    %MOTOR ON X-AXIS
    if isempty( valPSDPlotXField),
       valPSDPlotXField=1;
    end;
    if  ~isempty(myFieldNames),
        if length(myFieldNames)>=valPSDPlotXField,
            set(hpopMotorOnXAxis,'String',myFieldNames,...
							'Value', valPSDPlotXField);
        else
            set(hpopMotorOnXAxis,'String',myFieldNames,'Value', 1);
        end;
    else
        set(hpopMotorOnXAxis,'String','----');
    end;
    
    %NAME VARIABLE WITH PSD DATA
    if isempty(valPSDPlotPSD),
        valPSDPlotPSD=1;
    end;
     if  (~isempty(myFieldNames))
         if length(myFieldNames)>=valPSDPlotPSD,
            set(hpopNameVariableWithPSDData,'String',...
							myFieldNames,'Value', valPSDPlotPSD);
         else,
             set(hpopNameVariableWithPSDData,'String',...
						 	myFieldNames,'Value',1);
         end;
     else,
        set(hpopNameVariableWithPSDData,'String','----');
    end;
end

%MOTOR ON X-AXIS
function popMotorOnXAxis_Callback(source, eventdata)
    str=get(hpopMotorOnXAxis,'String');
    val=get(hpopMotorOnXAxis,'Value');
    PSDPlotXField=str{val};
    valPSDPlotXField=find(strcmp(PSDPlotXField,str),1);
end

%NAME VARIABLE WITH PSD DATA
function popNameVariableWithPSDData_Callback(source, eventdata)
%	global max_Ivalue min_Ivalue max_I min_I
	str=get(hpopNameVariableWithPSDData,'String');
	val=get(hpopNameVariableWithPSDData,'Value');
	PSDPlotPSD=str{val};
	valPSDPlotPSD=find(strcmp(PSDPlotPSD,str),1);
	flgIs2DArray=1;
 	cmd=['flgIs2DArray=isnumeric( ',MSpScn,'.',PSDPlotPSD, ');'];
 	eval(cmd);
  if flgIs2DArray,
    cmd=['flgIs2DArray=(sum(size( ',MSpScn,'.',PSDPlotPSD, ')>1)==2);'];
	  eval(cmd);
  end;
	if flgIs2DArray,
		cmd=['min_Ivalue=min(min( ',MSpScn,'.',PSDPlotPSD, '));'];
		eval(cmd);
		cmd=['max_Ivalue=max(max( ',MSpScn,'.',PSDPlotPSD, '));'];
		eval(cmd);
		set(hlbMinIVal , 'String',min_Ivalue);
		set(hlbMaxIVal , 'String',max_Ivalue);    
	else,
			msgbox('Warning: PSD data shoud be numeric and 2D');
	end;
	if nargin>0,
		max_Is=get(hedMaxIntensity,'String');
		max_I=str2num(max_Is);
		min_Is=get(hedMinIntensity,'String');
		min_I=str2num(min_Is);
		if max_I>max_Ivalue,
				set(hedMaxIntensity , 'String',max_Ivalue); 
		end;
		 if min_I<min_Ivalue,
				set(hedMinIntensity , 'String',min_Ivalue); 
		end;
	end;
end


%+IMAGE FORMAT
function popImageFormat_Callback(source, eventdata)
    str=get(hpopImageFormat,'String');
    val=get(hpopImageFormat,'Value');
    PrintFormat=str{val};
    valPrintFormat=find(strcmp(PrintFormat,str),1);
end

function checkPLotIntensityLogScale_Callback(source, eventdata),
% global max_Ivalue min_Ivalue max_I min_I
 flgIntLog=get(hcheckPLotIntensityLogScale,'Value');
	max_Is=get(hedMaxIntensity,'String');
	max_I=str2num(max_Is);
	min_Is=get(hedMinIntensity,'String');
	min_I=str2num(min_Is);
	if flgIntLog,
		if min_I<=0,
				min_I=1e-16;
				msgbox('Warning: minimal intensity should be >0 for Log plot!');
		end;
	end;
end
 
function checkPrintToFile_Callback(source, eventdata)
		flgPrintPlot=get(hcheckPrintToFile,'Value');
end
 
 
function btFileName_Callback(hObject,eventdata)
	persistent LocalDir
	if isempty(LocalDir),
	 LocalDir='';
	end;

	if isempty(LocalDir),
		mypath='./*.*';
	else
			mypath=[LocalDir,'*.*'];
	end;
	[file,mypath]=uiputfile(mypath);
	ind=findstr(file,'.*');
	if ~isempty(ind),
			file([ind:ind+1])='';
	end;

	LocalDir=mypath;
	set(hedFileName ,'String',[mypath,file]);
	FName=[mypath,file];
end

%PLOT
function pbPlot_Callback(source, eventdata)
%	global max_Ivalue min_Ivalue max_I min_I
	cmd='';
	PrintExt='eps';
	hfig=[];
	MSpScn;
	truncLogTop=0;
	truncLogBot=0;
	popDataSet2BePlotted_Callback();
	popMotorOnXAxis_Callback();
	popNameVariableWithPSDData_Callback();
	checkPLotIntensityLogScale_Callback();
	checkPrintToFile_Callback();
	popImageFormat_Callback();
	FName=get(hedFileName ,'String');
	flgUnspec=0;
	flgNormalize=0;
	flgAng2Q=0; %
	flgPlotPSD=1;
	flgAutoGridEst=0;
	flgGridQ=0;
	flgPlotGrid=0;
	flgSaveMat=0;
	flgLoadMat=0;
	flgSaveAscii=0;
    
	max_Is=get(hedMaxIntensity,'String');
	max_Ipl=str2num(max_Is);
	min_Is=get(hedMinIntensity,'String');
	min_Ipl=str2num(min_Is);
	if flgIntLog,
		if min_Ipl<=0,
			min_Ipl=1e-16;
			msgbox('Warning: minimal intensity should be >0 for Log plot!');
		end;
		min_Ipl=log10(min_Ipl);
		max_Ipl=log10(max_Ipl);
	end;
	MSpMain2;
	hndAx=findobj('tag','PSDRoughPlot');
	set(hndAx,'clim',[min_Ipl,max_Ipl]);
end


function pbClose_Callback(hObject,eventdata)
set(hndMainGUI,'Visible','On');
close(f0);
end

function closeIt(gcbf,ar2);
set(hndMainGUI,'Visible','On');
delete(f0);
end;
end
 
 
 

