function fig_hdl = SaveToASCII
% MatSpec GUI
% J. Novak, 08-11-13
% build: generate_m_file('SaveToASCII.fig','../')
% SAVETOASCII_BUILD
%-------------------------------------------------------------------------------
% File name   : SaveToASCII.m           
% Generated on: 13-Nov-2008 13:38:54          
%-------------------------------------------------------------------------------

% --- VARIABLES ----------------------------------
global MSpScnList MSpf  MSpScn;
persistent valPopExportToASCIIDatasetToHandle
persistent valListVariablesToSave
persistent strEditFilenameRoot TargetDirectory
persistent figPositon


if ~isempty(MSpScnList),
	n=length(MSpScnList );
	for ii = 1:n
			cmd=['global ', MSpScnList{ii}];
			eval(cmd);
	end;
end;

if isempty(valPopExportToASCIIDatasetToHandle),
	valPopExportToASCIIDatasetToHandle=1;
end;
if isempty(valListVariablesToSave),
	valListVariablesToSave=[];
end;
if isempty(strEditFilenameRoot),
	strEditFilenameRoot='s1';
end;
if isempty(TargetDirectory),
	TargetDirectory='./';
end;
if isempty(figPositon),
	figPositon=[103.8 31.3 56.8 30.0];
end;

fig_hdl=findobj('tag','figExportASCII');
hndMainGUI=findobj('Tag','figGUIMatSpec');
set(hndMainGUI,'Visible','Off');
if isempty(fig_hdl),
% --- FIGURE -------------------------------------
handles.figExportASCII = figure(	'Tag', 'figExportASCII', ...
	'Units', 'characters', ...
	'Position', figPositon, ...
	'Name', 'MatSpec: Export to ASCII', ...
	'MenuBar', 'none', ...
	'NumberTitle', 'off', ...
	'Visible','Off',...
	'Color', get(0,'DefaultUicontrolBackgroundColor'), ...
	'CloseRequestFcn',{@closeIt},...
	'WindowButtonMotionFcn', @figExportASCII_WindowButtonMotionFcn);

% Scale factor to accomodate figure for the system specific graphical properties
%htmp=uicontrol('Style','text','units','pixels',...
%	'fontunits','pixels','position',[10 10 20 10],...
%	'fontsize',10,'string','jg');
%curH=get(htmp,'Extent');
%scalingFact=curH(4)/get(htmp,'fontsize')*.8;
%delete(htmp);

% --- STATIC TEXTS -------------------------------------
handles.txtExportASCIIDatasetToHandle = uicontrol(	'Parent', handles.figExportASCII, ...
	'Tag', 'txtExportASCIIDatasetToHandle', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [3.1 24 19 1.4], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Data-set to handle', ...
	'HorizontalAlignment', 'left');

handles.txtVariablesToSave = uicontrol(	'Parent', handles.figExportASCII, ...
	'Tag', 'txtVariablesToSave', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [3.1 21.1 19 1.4], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Variables to save', ...
	'HorizontalAlignment', 'left');

handles.txtFilenameRoot = uicontrol(	'Parent', handles.figExportASCII, ...
	'Tag', 'txtFilenameRoot', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [3.1 4 19 1.4], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Filename root', ...
	'HorizontalAlignment', 'left');

handles.txtTileExprotToASCII = uicontrol(	'Parent', handles.figExportASCII, ...
	'Tag', 'txtTileExprotToASCII', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [9.3 27.5 38.1 1.9], ...
	'FontName', 'Helvetica', ...
	'FontSize', 18, ...
	'FontWeight', 'bold', ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Export to ASCII File');

% --- PUSHBUTTONS -------------------------------------
handles.pushExport = uicontrol(	'Parent', handles.figExportASCII, ...
	'Tag', 'pushExport', ...
	'UserData', [], ...
	'Style', 'pushbutton', ...
	'Units', 'characters', ...
	'Position', [23.3 0.6 13.5 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'FontWeight', 'bold', ...
	'String', 'Export', ...
	'Callback', @pushExport_Callback);

handles.pushClose = uicontrol(	'Parent', handles.figExportASCII, ...
	'Tag', 'pushClose', ...
	'UserData', [], ...
	'Style', 'pushbutton', ...
	'Units', 'characters', ...
	'Position', [41.3 0.6 13.5 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'FontWeight', 'bold', ...
	'String', 'Close', ...
	'Callback', @pushClose_Callback);

% --- EDIT TEXTS -------------------------------------
handles.editFilenameRoot = uicontrol(	'Parent', handles.figExportASCII, ...
	'Tag', 'editFilenameRoot', ...
	'UserData', [], ...
	'Style', 'edit', ...
	'Units', 'characters', ...
	'Position', [23.1 3.8 31.6 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [1 1 1], ...
	'String', {'Edit Text'}, ...
	'HorizontalAlignment', 'left', ...
	'Callback', @editFilenameRoot_Callback, ...
	'CreateFcn', @editFilenameRoot_CreateFcn);

% --- LISTBOXES -------------------------------------
handles.listVariablesToSave = uicontrol(	'Parent', handles.figExportASCII, ...
	'Tag', 'listVariablesToSave', ...
	'UserData', [], ...
	'Style', 'listbox', ...
	'Units', 'characters', ...
	'Position', [23.1 6.5 31.6 16.6], ...
	'FontName', 'Helvetica', ...
	'Min',0,'Max',2,...
	'FontSize', 12, ...
	'String', {'Listbox'}, ...
	'Callback', @listVariablesToSave_Callback, ...
	'CreateFcn', @listVariablesToSave_CreateFcn);

% --- POPUP MENU -------------------------------------
handles.popExportToASCIIDatasetToHandle = uicontrol(	'Parent', handles.figExportASCII, ...
	'Tag', 'popExportToASCIIDatasetToHandle', ...
	'UserData', [], ...
	'Style', 'popupmenu', ...
	'Units', 'characters', ...
	'Position', [23.1 23.7 31.6 1.8], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', {'Pop-up Menu'}, ...
	'Callback', @popExportToASCIIDatasetToHandle_Callback, ...
	'CreateFcn', @popExportToASCIIDatasetToHandle_CreateFcn);

% Save handles structure
guidata(handles.figExportASCII,handles);

% Scale size to fit the text in
%objFieldnames=fieldnames(handles);
%for ii=1:length(objFieldnames),
%	curPos=get(handles.(objFieldnames{ii}),'Position');
%	newPos=curPos*scalingFact;
%	set(handles.(objFieldnames{ii}),'Position',newPos);
%end;
% Assign function output
fig_hdl = handles.figExportASCII;

movegui(fig_hdl,'center');
set(fig_hdl,'visible','on');
else
figure(fig_hdl);
end;

%-------------------------------------------------------------------------------
	function figExportASCII_WindowButtonMotionFcn(hObject,evendata)
		figPositon=get(handles.figExportASCII,'Position');
	end

%-------------------------------------------------------------------------------
	function pushExport_Callback(hObject,evendata)
		cvar=1;
		flgOverwriteAll=0;
		cstr1= 'Yes'; 
		cstr2='Skip';
		cstr3='Yes all';
		MSpScn=getPopCurStr(handles.popExportToASCIIDatasetToHandle);
		cFields=get(handles.listVariablesToSave,'String');
		valListVariablesToSave=get(handles.listVariablesToSave,'Value');
		strEditFilenameRoot=get(handles.editFilenameRoot,'String');
		TargetDirectory=uigetdir(TargetDirectory,'Directorty to Save in');
		for ii=valListVariablesToSave,
			cmd=['cvar=',MSpScn,'.',cFields{ii},';'];
			eval(cmd);
			cFile=[strEditFilenameRoot,'_',cFields{ii},'.dat'];
			cFullName=fullfile(TargetDirectory,cFile);
			if exist(cFullName,'file') & flgOverwriteAll~=1,
				str=sprintf('File %s already exist. Overwrite?',cFullName);
				butAnsw=questdlg(str,'Output file exist', cstr2,cstr1,cstr3,...
					cstr2);
				switch butAnsw,
					case cstr2,
						continue;
					case cstr3
						flgOverwriteAll=1;
				end;
			end;
			if isnumeric(cvar),
				cvar=double(cvar);
				save(cFullName,'cvar','-ascii');
			elseif isstr(cvar),
				fid=fopen(cFullName,'w');
				fprintf(fid,'%s',cvar);
				fclose(fid);
			end;
		end;
		MSpScn
strEditFilenameRoot
TargetDirectory
		str=['Selected variables from dataset ',MSpScn, ' were ',...
			'saved to the file(s) named ',strEditFilenameRoot,...
			'_*.dat in ',...
			'the directory ', TargetDirectory, '.'];
		msgbox(str); 
	end

%-------------------------------------------------------------------------------
	function pushClose_Callback(hObject,evendata)
		figPositon=get(handles.figExportASCII,'Position');
		valListVariablesToSave=get(handles.listVariablesToSave,'Value');
		set(hndMainGUI,'Visible','On');
		close(fig_hdl);
	end

%-------------------------------------------------------------------------------
	function editFilenameRoot_Callback(hObject,evendata)
		strEditFilenameRoot=get(handles.editFilenameRoot,...
			'String');
	end

%-------------------------------------------------------------------------------
	function editFilenameRoot_CreateFcn(hObject,evendata)
		set(hObject,'String',...
			strEditFilenameRoot);
	end

%-------------------------------------------------------------------------------
	function listVariablesToSave_Callback(hObject,evendata)
		valListVariablesToSave=get(handles.listVariablesToSave,...
			'Value');
	end

%-------------------------------------------------------------------------------
	function listVariablesToSave_CreateFcn(hObject,evendata)
		myFieldNames=retrieveDataFields;
		setListFieldNames(hObject,myFieldNames,valListVariablesToSave);
	end

%-------------------------------------------------------------------------------
	function popExportToASCIIDatasetToHandle_Callback(hObject,evendata)
		MSpScn=getPopCurStr(handles.popExportToASCIIDatasetToHandle);
		myFieldNames=retrieveDataFields;
		setListFieldNames(handles.listVariablesToSave,...
			myFieldNames,valListVariablesToSave);
	end

%-------------------------------------------------------------------------------
	function popExportToASCIIDatasetToHandle_CreateFcn(hObject,evendata)
		if (~isempty(MSpScn) && ~isempty(MSpScnList)),
				ii=find(strcmp(MSpScn,MSpScnList),1);
				set(hObject,'String',MSpScnList,'Value', ii);
		elseif length(MSpScnList)>0,
				set(hObject,'String',MSpScnList,'Value', 1);
		else
				set(hObject,'String',{'------'});
		end;
	end
%-------------------------------------------------------------------------------
function closeIt(gcbf,ar2);
set(hndMainGUI,'Visible','On');
delete(fig_hdl);
end;
%-------------------------------------------------------------------------------
	function myFieldNames=retrieveDataFields;
		% retrieve fields of the dataset
		myFieldNames={};
		flgIsStruct=0;
		if ~isempty(MSpScn),
				if  iscell(MSpScn),
						MSpScn=MSpScn{1};
				end;
				cmd=['flgIsStruct=isstruct(', MSpScn,');'];
				eval(cmd);
				if flgIsStruct,
						cmd=['myFieldNames=fieldnames(',MSpScn,');'];
						eval(cmd);
				else
						myFieldNames={};
				end;
		else,
				myFieldNames={};
		end;
	end;

	function val1=setListFieldNames( hndl, str, val),
		% Set list box field names and the current filed (val)
		% hndl ... handle to the list box
		% str ... string
		% val ... value
		if (isempty(str)),
			lstr=1;
			str={'------'};
		else if (iscell(str)),
			lstr=length(str);
		else
			lstr=1;
		end;
		end;

		if (any(val>lstr)),
			val=[];
		end;
		
		set(hndl,'String',str);
		set(hndl,'Value',val);
		val1=val;
	end;

	function str=getPopCurStr(hndl),
		strs=get(hndl,'String');
		ii=get(hndl,'Value');
		str=strs{ii};
	end;
end
