 %SetMotorOffset.m
 
 function SetMotorOffset

global MotDetOff MotorList MotorOffsets MotorNames;
disp(MotDetOff);
mySeparator=', ';

if ~exist('MotDetOff','var'),
    MotDetOff={};
end;
%create empty cellArrays to manage motor_names and motor_offsets.
nMDO=length(MotDetOff);
if nMDO==0,
    MotorNames={};
    MotorOffsets={};
    MotorList={};
    motnam='';
    motoff='';
else
    for ii=1:nMDO/2,
        MotorNames{ii}=MotDetOff{2*ii-1};
        MotorOffsets{ii}=num2str(MotDetOff{2*ii});
        MotorList{ii}=[MotorNames{ii}, mySeparator, MotorOffsets{ii}];
       motnam=MotorNames{1};
       motoff=MotorOffsets{1};
    end
end;

%create GUI
initPosH=round(rand()*100);
initPosV=round(rand()*100);
f0=figure('Visible','off','Position',[initPosH,initPosV,240,200]);
set(f0,'Name','Set motor offset');
set(f0,'Visible','on');

hPopAddMotor= uicontrol('Style','listbox','String',MotorList,'Position',[20,110,200,80],'Callback',{@popAddMotor_Callback});
hEdAddMotorName= uicontrol('Style','edit','String',motnam,'Position',[20,80,100,25]);
hEdAddMotorOffset= uicontrol('Style','edit','String',motoff,'Position',[120,80,100,25]);
hBtAddMotor=uicontrol('Style','pushbutton','String','Add/Modofy','Position',[20,50,100,25],'Callback',{@btAddMotor_Callback});
hBtDelete=uicontrol('Style','pushbutton','String','Delete','Position',[120,50,100,25],'Callback',{@btDelete_Callback});
hBtOk=uicontrol('Style','pushbutton','String','OK','Position',[20,20,200,25],'Callback',{@btOk_Callback});




function btDelete_Callback(source, eventdata)
    disp('\\\\\\\\\\\\\\\\\\\\\\\\\\\\');
     motnam=get(hEdAddMotorName,'String');
     motoff=get(hEdAddMotorOffset,'String');
%      motnam=motnam{1};
  %   motoff=motoff{1};
    % motnam=motnam(1);
   %  motoff=motoff(1);
     ii=find(strcmp( motnam,MotorNames),1);
     disp(motnam);
     disp(ii)
     MotorNames(ii)=[];
     MotorOffsets(ii)=[];
     MotorList(ii)=[];
    disp(MotorList);
    set(hPopAddMotor,'String',MotorList);
    set(hPopAddMotor,'Value',1);
end


function btAddMotor_Callback(source, eventdata)
   disp('***********************');
   motnam=get(hEdAddMotorName,'String');
   motoff=get(hEdAddMotorOffset,'String');
    % motnam=motnam(1);
   %  motoff=motoff(1);
    if ~any(strcmp(MotorNames,motnam)),
        disp('debug0');
        n=length(MotorNames);
        MotorNames{n+1}=motnam;
         MotorOffsets{n+1}=motoff;
         MotorList{n+1}=[motnam, mySeparator, motoff];
    else
        disp('debug1');
        ii=find(strcmp( motnam,MotorNames),1);
        disp(ii);
        MotorNames{ii}=motnam;
        MotorOffsets{ii}=motoff;
        MotorList{ii}=[motnam, mySeparator, motoff];
  end;
  disp(MotorNames);
  disp(MotorOffsets);
  disp(MotorList);
  if isempty(MotorList),
      MotorList={};
  end;
  set(hPopAddMotor,'String',MotorList);
  
end

function popAddMotor_Callback(source, eventdata)
    disp('++++++++++++++++++++++++++');
    str0=get(source,'String');
    val=get(source,'Value');
    mystr=str0{val};
    st=split(mySeparator, mystr);
    disp(val);
    disp(mystr);
    disp(st);
    disp(st(1));
    disp(st(2));
    set(hEdAddMotorName,'String',st(1));
    set(hEdAddMotorOffset,'String',st(2));
   
end


function btOk_Callback(source, eventdata)
    disp('---------------------------');
     nMN=length(MotorNames);
    if nMN==0,
        MotDetOff={};
    else
        for ii=1:nMN
            MotDetOff{2*ii-1}=MotorNames{ii};
             MotDetOff{2*ii}=str2num(MotorOffsets{ii});
        end
   end;
   disp(MotDetOff);

end


 end
 
 
 

