function fstr=SpOpen(fname);
% function fstr=SpOpen(fname);
% Open specfile fname, creates a table of the scans
% fstr ... structure with records concerning the file
% 	fstr.fid ... pointer to the file
%		fstr.fheadpos ... positions of the start of the scans in the file
% (c) 2007, Jiri Novak, ESRF Grenoble, France
 
%%%%
% This program comes with ABSOLUTELY NO WARRANTY.  This is free
% software distributed under GNU licence, see
% http://www.gnu.org/licenses/ or the attached file GPLicense.txt



%
fids=fopen('all');
indOpened=0;
fstr.fid=fopen(fname,'r');
fstr.fname=fopen(fstr.fid);
% Was the file already opened?
for ii=1:length(fids),
	OName=fopen(fids(ii));
	if strcmp(OName,fstr.fname),
		indOpened=ii;
		break;
	end;
end;
if indOpened,
	fclose(fstr.fid);
	fstr.fid=fids(indOpened);
end;

% Read data
fseek(fstr.fid,0,-1);
dat=fread(fstr.fid,inf,'uchar=>uchar');
tdat=char(dat');
% Beginning of the file head
fstr.fheadpos=strfind(tdat,'#F')-1;
% Beginnings and ends of the scan positions
[fstr.scnpos,fstr.scnposEnd]=headpos(tdat);

% Find scan numbers
nn=length(fstr.scnpos);
ii=1;
while ii<=nn,
	if ~strcmp(tdat(fstr.scnpos(ii)+[1:2]),'#S'),
%		error('Can not read scans in %s\n',fstr.fname);
		fstr.scnpos(ii)=[];
		fstr.scnposEnd(ii)=[];
		nn=nn-1;	
	else
		fstr.scnum(ii)=sscanf(tdat([fstr.scnpos(ii):fstr.scnposEnd(ii)]+1),'#S %d');
		ii=ii+1;
	end;
end;
fstr.fhead=tdat([fstr.fheadpos:fstr.scnpos(1)]+1);
fhead1=SpPurifyHeadChunk2(fstr.fhead,'#O\d+','\n');
fstr.MotNames=SpStr2cell(fhead1);


function [hs,hf]=headpos(tdat);
% Finds beginnings and ends of continues scan heads
% Find limits of head lines
[sc,ec]=regexp(tdat,'#[^\n]*');
% Where head continues on the next line?
df=sc(2:end)-ec(1:end-1)-2;
ind=find(df==0);
sc(ind+1)=[];
ec(ind)=[];
hs=sc-1; hf=ec-1;
% Skip file head
hs(1)=[];
hf(1)=[];
