function ostr=SpPurifyHeadChunk2(istr,sregex,fregex)
% function ostr=SpPurifyHeadChunk2(istr,sregex,fregex)
% Returns all lines from a Spec header starting with regular expression
% sregex and finishing with fregex. Removes all sregex and fregex.
% (c) 2007, Jiri Novak, ESRF Grenoble, France
 
%%%%
% This program comes with ABSOLUTELY NO WARRANTY.  This is free
% software distributed under GNU licence, see
% http://www.gnu.org/licenses/ or the attached file GPLicense.txt


[spos1,spos2]=regexp(istr,sregex);
if isempty(spos1),
	error('Regular expression %s not found\n',sregex);
end;
[fpos1,fpos2]=regexp(istr(spos2(end)+1:end),fregex);
ostr=istr(spos1(1):spos2(end)+fpos2(1));
ostr=regexprep(ostr,sregex,' ');
ostr=regexprep(ostr,fregex,' ');
% remove redundant blank characters
ostr=regexprep(ostr,'\s+',' ');
% remove spaces at the end
ostr=deblank(ostr);


